(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global.mixomatic = factory());
}(this, (function () { 'use strict';

  function createMixin(propertyDescriptors) {
    const mixed = new WeakSet();

    function mixin(obj) {
      Object.defineProperties(obj, propertyDescriptors);
      mixed.add(obj);
      return obj;
    }

    function checkInstance(obj) {
      for (let o = obj; o; o = Object.getPrototypeOf(o)) {
        if (mixed.has(o)) {
          return true;
        }
      }
    }

    Object.defineProperty(mixin, Symbol.hasInstance, { value: checkInstance });

    return mixin;
  }

  return createMixin;

})));
